Index: /GTP/trunk/Lib/Vis/Preprocessing/src/preprocessor-noqt.vcproj
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/preprocessor-noqt.vcproj	(revision 1217)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/preprocessor-noqt.vcproj	(revision 1217)
@@ -0,0 +1,261 @@
+<?xml version="1.0" encoding = "Windows-1252"?>
+<VisualStudioProject
+	ProjectType="Visual C++"
+	Version="7.10"
+	Name="preprocessor"
+	ProjectGUID="{271D0DE4-A85A-35D0-AD6E-4E997713F9B2}"
+	Keyword="Qt4VSv1.0">
+	<Platforms>
+		<Platform
+			Name="Win32"/>
+	</Platforms>
+	<Configurations>
+		<Configuration
+			Name="Release|Win32"
+			OutputDirectory="."
+			ATLMinimizesCRunTimeLibraryUsage="false"
+			ConfigurationType="1"
+			IntermediateDirectory="release\"
+			UseOfMfc="0">
+			<Tool
+				Name="VCCLCompilerTool"
+				AdditionalIncludeDirectories="&quot;..\src&quot;,&quot;..\..\..\..\..\..\NonGTP\Xerces\xerces\include&quot;,&quot;..\..\..\..\..\..\NonGTP\Zlib\include&quot;,&quot;..\..\..\..\..\..\NonGTP\Boost&quot;,&quot;..\..\..\..\..\..\NonGTP\Devil\include&quot;,&quot;.&quot;,C:/Qt/4.1.2/mkspecs/win32-msvc.net"
+				AdditionalOptions="-Zm200 -EHsc -Zm200 -EHsc"
+				AssemblerListingLocation="release\"
+				BufferSecurityCheck="false"
+				DebugInformationFormat="0"
+				ExceptionHandling="true"
+				GeneratePreprocessedFile="0"
+				ObjectFile="release\"
+				Optimization ="2"
+				PreprocessorDefinitions="QT_NO_DEBUG,NDEBUG,UNICODE,WIN32,QT_LARGEFILE_SUPPORT,NDEBUG"
+				ProgramDataBaseFileName=".\"
+				RuntimeLibrary="2"
+				RuntimeTypeInfo="true"
+				SuppressStartupBanner="true"
+				WarningLevel="0"/>
+			<Tool
+				Name="VCCustomBuildTool"/>
+			<Tool
+				Name="VCLinkerTool"
+				AdditionalDependencies="xerces-c_2.lib devil.lib ilu.lib ilut.lib glew32.lib zlib.lib"
+				AdditionalLibraryDirectories="GL,..\..\..\..\..\..\NonGTP\Xerces\xerces\lib,..\..\..\..\..\..\NonGTP\Devil\lib,..\..\..\..\..\..\NonGTP\glut,..\..\..\..\..\..\NonGTP\Boost\lib,..\..\..\..\..\..\NonGTP\Zlib\lib"
+				GenerateDebugInformation="false"
+				IgnoreDefaultLibraryNames="&quot;libc&quot;,LIBCMT,LIBCMT"
+				IgnoreImportLibrary="true"
+				LinkIncremental="2"
+				OutputFile="&quot;..\bin\release&quot;\preprocessor.exe"
+				ProgramDatabaseFile=""
+				SubSystem="0"
+				SuppressStartupBanner="true"/>
+			<Tool
+				Name="VCMIDLTool"
+				DefaultCharType="0"
+				EnableErrorChecks="1"
+				WarningLevel="0"/>
+			<Tool
+				Name="VCPostBuildEventTool"/>
+			<Tool
+				Name="VCPreBuildEventTool"/>
+			<Tool
+				Name="VCPreLinkEventTool"/>
+			<Tool
+				Name="VCResourceCompilerTool"
+				PreprocessorDefinitions="QT_NO_DEBUG,NDEBUG,UNICODE,WIN32,QT_LARGEFILE_SUPPORT"/>
+		</Configuration>
+		<Configuration
+			Name="Debug|Win32"
+			OutputDirectory="."
+			ATLMinimizesCRunTimeLibraryUsage="false"
+			ConfigurationType="1"
+			IntermediateDirectory="debug\"
+			UseOfMfc="0">
+			<Tool
+				Name="VCCLCompilerTool"
+				AdditionalIncludeDirectories="&quot;..\src&quot;,&quot;..\..\..\..\..\..\NonGTP\Xerces\xerces\include&quot;,&quot;..\..\..\..\..\..\NonGTP\Zlib\include&quot;,&quot;..\..\..\..\..\..\NonGTP\Boost&quot;,&quot;..\..\..\..\..\..\NonGTP\Devil\include&quot;,&quot;.&quot;,C:/Qt/4.1.2/mkspecs/win32-msvc.net"
+				AdditionalOptions="-Zm200 -EHsc -Zm200 -EHsc"
+				AssemblerListingLocation="debug\"
+				BufferSecurityCheck="false"
+				DebugInformationFormat="3"
+				ExceptionHandling="true"
+				GeneratePreprocessedFile="0"
+				ObjectFile="debug\"
+				Optimization ="4"
+				PreprocessorDefinitions="UNICODE,WIN32,QT_LARGEFILE_SUPPORT"
+				ProgramDataBaseFileName=".\"
+				RuntimeLibrary="3"
+				RuntimeTypeInfo="true"
+				SuppressStartupBanner="true"
+				WarningLevel="0"/>
+			<Tool
+				Name="VCCustomBuildTool"/>
+			<Tool
+				Name="VCLinkerTool"
+				AdditionalDependencies="xerces-c_2.lib devil.lib ilu.lib ilut.lib glew32.lib zlib.lib"
+				AdditionalLibraryDirectories="GL,..\..\..\..\..\..\NonGTP\Xerces\xerces\lib,..\..\..\..\..\..\NonGTP\Devil\lib,..\..\..\..\..\..\NonGTP\glut,..\..\..\..\..\..\NonGTP\Boost\lib,..\..\..\..\..\..\NonGTP\Zlib\lib"
+				GenerateDebugInformation="true"
+				IgnoreDefaultLibraryNames="&quot;libc&quot;,LIBCMT,LIBCMT"
+				IgnoreImportLibrary="true"
+				OutputFile="&quot;..\bin\debug&quot;\preprocessor.exe"
+				ProgramDatabaseFile=""
+				SubSystem="0"
+				SuppressStartupBanner="true"/>
+			<Tool
+				Name="VCMIDLTool"
+				DefaultCharType="0"
+				EnableErrorChecks="1"
+				WarningLevel="0"/>
+			<Tool
+				Name="VCPostBuildEventTool"/>
+			<Tool
+				Name="VCPreBuildEventTool"/>
+			<Tool
+				Name="VCPreLinkEventTool"/>
+			<Tool
+				Name="VCResourceCompilerTool"
+				PreprocessorDefinitions="UNICODE,WIN32,QT_LARGEFILE_SUPPORT"/>
+		</Configuration>
+	</Configurations>
+	<Files>
+		<Filter
+			Name="Source Files"
+			Filter="cpp;c;cxx;def;odl;idl;hpj;bat;asm;asmx"
+			UniqueIdentifier="{4FC737F1-C7A5-4376-A066-2A32D752A2FF}">
+			<File
+				RelativePath="AxisAlignedBox3.cpp"/>
+			<File
+				RelativePath="Beam.cpp"/>
+			<File
+				RelativePath="BoostPreprocessorThread.cpp"/>
+			<File
+				RelativePath="Camera.cpp"/>
+			<File
+				RelativePath="Environment.cpp"/>
+			<File
+				RelativePath="ExactPreprocessor.cpp"/>
+			<File
+				RelativePath="Exporter.cpp"/>
+			<File
+				RelativePath="GlRenderer.cpp"/>
+			<File
+				RelativePath="GzBinFileInputStream.cpp"/>
+			<File
+				RelativePath="GzFileInputSource.cpp"/>
+			<File
+				RelativePath="Halton.cpp"/>
+			<File
+				RelativePath="KdIntersectable.cpp"/>
+			<File
+				RelativePath="KdTree.cpp"/>
+			<File
+				RelativePath="LogManager.cpp"/>
+			<File
+				RelativePath="Material.cpp"/>
+			<File
+				RelativePath="Matrix4x4.cpp"/>
+			<File
+				RelativePath="Mesh.cpp"/>
+			<File
+				RelativePath="MeshKdTree.cpp"/>
+			<File
+				RelativePath="MutualVisibility.cpp"/>
+			<File
+				RelativePath="Plane3.cpp"/>
+			<File
+				RelativePath="PlyParser.cpp"/>
+			<File
+				RelativePath="Polygon3.cpp"/>
+			<File
+				RelativePath="Preprocessor.cpp"/>
+			<File
+				RelativePath="PreprocessorThread.cpp"/>
+			<File
+				RelativePath="Pvs.cpp"/>
+			<File
+				RelativePath="Ray.cpp"/>
+			<File
+				RelativePath="RayInfo.cpp"/>
+			<File
+				RelativePath="Rectangle3.cpp"/>
+			<File
+				RelativePath="RenderSampler.cpp"/>
+			<File
+				RelativePath="RenderSimulator.cpp"/>
+			<File
+				RelativePath="Renderer.cpp"/>
+			<File
+				RelativePath="RssPreprocessor.cpp"/>
+			<File
+				RelativePath="RssTree.cpp"/>
+			<File
+				RelativePath="SamplingPreprocessor.cpp"/>
+			<File
+				RelativePath="SamplingStrategy.cpp"/>
+			<File
+				RelativePath="SceneGraph.cpp"/>
+			<File
+				RelativePath="Tetrahedron3.cpp"/>
+			<File
+				RelativePath="Triangle3.cpp"/>
+			<File
+				RelativePath="UnigraphicsParser.cpp"/>
+			<File
+				RelativePath="Vector3.cpp"/>
+			<File
+				RelativePath="ViewCell.cpp"/>
+			<File
+				RelativePath="ViewCellBsp.cpp"/>
+			<File
+				RelativePath="ViewCellsManager.cpp"/>
+			<File
+				RelativePath="ViewCellsParser.cpp"/>
+			<File
+				RelativePath="VrmlExporter.cpp"/>
+			<File
+				RelativePath="VspBspTree.cpp"/>
+			<File
+				RelativePath="VspOspTree.cpp"/>
+			<File
+				RelativePath="VssPreprocessor.cpp"/>
+			<File
+				RelativePath="VssRay.cpp"/>
+			<File
+				RelativePath="VssTree.cpp"/>
+			<File
+				RelativePath="X3dExporter.cpp"/>
+			<File
+				RelativePath="X3dParser.cpp"/>
+			<File
+				RelativePath="common.cpp"/>
+			<File
+				RelativePath="gzstream.cpp"/>
+			<File
+				RelativePath="main.cpp"/>
+			<File
+				RelativePath="plyfile.c"/>
+		</Filter>
+		<Filter
+			Name="Header Files"
+			Filter="h;hpp;hxx;hm;inl;inc;xsd"
+			UniqueIdentifier="{93995380-89BD-4b04-88EB-625FBE52EBFB}">
+			<File
+				RelativePath="Beam.h"/>
+			<File
+				RelativePath="GlRenderer.h"/>
+			<File
+				RelativePath="Halton.h"/>
+			<File
+				RelativePath="Preprocessor.h"/>
+			<File
+				RelativePath="PreprocessorThread.h"/>
+			<File
+				RelativePath="RssTree.h"/>
+			<File
+				RelativePath="VssPreprocessor.h"/>
+			<File
+				RelativePath="VssRay.h"/>
+		</Filter>
+	</Files>
+	<Globals>
+	</Globals>
+</VisualStudioProject>
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/Makefile
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/Makefile	(revision 1213)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/Makefile	(revision 1217)
@@ -1,5 +1,5 @@
 #############################################################################
 # Makefile for building: preprocessor
-# Generated by qmake (2.00a) (Qt 4.1.2) on: ?t 17. VIII 21:11:20 2006
+# Generated by qmake (2.00a) (Qt 4.1.2) on: ?t 17. VIII 21:45:14 2006
 # Project:  preprocessor.pro
 # Template: app
@@ -107,5 +107,5 @@
 all: release-all debug-all FORCE
 clean: release-clean debug-clean FORCE
-	-$(DEL_FILE) preprocessor.exp
+	-$(DEL_FILE) "..\bin\release"\preprocessor.exp
 distclean: release-distclean debug-distclean FORCE
 	-$(DEL_FILE) Makefile
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/preprocessor.pro
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/preprocessor.pro	(revision 1213)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/preprocessor.pro	(revision 1217)
@@ -5,4 +5,12 @@
 
 TARGET = preprocessor
+
+CONFIG(debug) {
+DESTDIR = "../bin/debug"
+}
+
+CONFIG(release) {
+DESTDIR = "../bin/release"
+}
 
 NONGTP = ../../../../../../NonGTP
@@ -39,5 +47,7 @@
 
 win32:LIBS += xerces-c_2.lib devil.lib ilu.lib ilut.lib \
-glew32.lib zlib.lib /NODEFAULTLIB:LIBCMT
+glew32.lib zlib.lib 
+
+QMAKE_LFLAGS_CONSOLE=/NODEFAULTLIB:LIBCMT
 
 CONFIG(qt) {