Index: GTP/trunk/Lib/Vis/OnlineCullingCHC/OGRE/include/OgreOcclusionCullingSceneManager.h
===================================================================
--- GTP/trunk/Lib/Vis/OnlineCullingCHC/OGRE/include/OgreOcclusionCullingSceneManager.h	(revision 938)
+++ GTP/trunk/Lib/Vis/OnlineCullingCHC/OGRE/include/OgreOcclusionCullingSceneManager.h	(revision 1221)
@@ -64,5 +64,5 @@
 	/** Override pass so we can do the z-fail pass. 
 	*/
-	const Pass* _setPass(Pass* pass);
+	virtual const Pass* _setPass(const Pass* pass, bool evenIfSuppressed = false);
 
 	/** Override from SceneManager so we can skip all but first pass for depth pass. 
@@ -124,14 +124,4 @@
 	*/
 	void InitVisibilityCulling(Camera *cam);
-#if 0
-	/** Finds object corresponding to this bounding box in the scene.
-	*/
-	Entity *FindCorrespondingObject(const AxisAlignedBox &box);
-
-	/** Identifies objects in the scene and gives them unique ids that
-		correspond to preprocessor ids.
-	*/
-	void IdentifyObjects(GtpVisibilityPreprocessor::ObjectContainer &objects);
-#endif
 	/** Loads / unloads pvs of the view cell to set the visibility in the scene.
 	*/
@@ -145,4 +135,7 @@
 	*/
 	void SetObjectsVisible(const bool visible);
+
+	
+	//////////////////////////////////////////
 
 	/// the interface to the scene hierarchy.
Index: GTP/trunk/Lib/Vis/OnlineCullingCHC/OGRE/include/OgreKdTreeSceneManager.h
===================================================================
--- GTP/trunk/Lib/Vis/OnlineCullingCHC/OGRE/include/OgreKdTreeSceneManager.h	(revision 1214)
+++ GTP/trunk/Lib/Vis/OnlineCullingCHC/OGRE/include/OgreKdTreeSceneManager.h	(revision 1221)
@@ -92,5 +92,5 @@
 	/** Override pass so we can do the z-fail pass.
 	*/
-	const Pass* _setPass(Pass* pass);
+	virtual const Pass* _setPass(const Pass* pass, bool evenIfSuppressed = false);
 
 	/** Render a queue group. 
Index: GTP/trunk/Lib/Vis/OnlineCullingCHC/OGRE/scripts/Plugin_VisibilitySceneManager.vcproj
===================================================================
--- GTP/trunk/Lib/Vis/OnlineCullingCHC/OGRE/scripts/Plugin_VisibilitySceneManager.vcproj	(revision 1206)
+++ GTP/trunk/Lib/Vis/OnlineCullingCHC/OGRE/scripts/Plugin_VisibilitySceneManager.vcproj	(revision 1221)
@@ -109,5 +109,5 @@
 				LinkIncremental="1"
 				SuppressStartupBanner="TRUE"
-				AdditionalLibraryDirectories="&quot;$(OGRE_PATH)\PlugIns\OctreeSceneManager\bin\$(ConfigurationName)&quot;;&quot;$(OGRE_PATH)\OgreMain\lib\$(ConfigurationName)&quot;;&quot;$(OGRE_PATH)\Samples\Common\CEGUIRenderer\lib&quot;;&quot;..\..\GtpVisibility\lib\$(ConfigurationName)&quot;;&quot;..\..\lib\$(ConfigurationName)&quot;;&quot;..\lib\$(ConfigurationName)&quot;;&quot;$(OGRE_PATH)\Dependencies\lib\$(ConfigurationName)&quot;;&quot;..\..\..\Preprocessing\lib\$(ConfigurationName)&quot;;..\..\..\..\..\..\..\NonGTP\Xerces\xercesc\lib;&quot;$(QTDIR)\lib&quot;;..\..\..\Preprocessing\src\GL;&quot;$(CG_LIB_PATH)&quot;;..\..\..\..\..\..\..\NonGTP\Zlib\lib"
+				AdditionalLibraryDirectories="&quot;$(OGRE_PATH)\PlugIns\OctreeSceneManager\bin\$(ConfigurationName)&quot;;&quot;$(OGRE_PATH)\OgreMain\lib\$(ConfigurationName)&quot;;&quot;$(OGRE_PATH)\Samples\Common\CEGUIRenderer\lib&quot;;&quot;..\..\GtpVisibility\lib\$(ConfigurationName)&quot;;&quot;..\..\lib\$(ConfigurationName)&quot;;&quot;..\lib\$(ConfigurationName)&quot;;&quot;$(OGRE_PATH)\Dependencies\lib\$(ConfigurationName)&quot;;&quot;..\..\..\Preprocessing\lib\$(ConfigurationName)&quot;;..\..\..\..\..\..\..\NonGTP\Xerces\xercesc\lib;..\..\..\Preprocessing\src\GL;&quot;$(CG_LIB_PATH)&quot;;..\..\..\..\..\..\..\NonGTP\Zlib\lib"
 				ModuleDefinitionFile="..\misc\OgreVisibilitySceneManager.def"
 				GenerateDebugInformation="TRUE"
Index: GTP/trunk/Lib/Vis/OnlineCullingCHC/OGRE/src/OgreOcclusionCullingSceneManager.cpp
===================================================================
--- GTP/trunk/Lib/Vis/OnlineCullingCHC/OGRE/src/OgreOcclusionCullingSceneManager.cpp	(revision 1220)
+++ GTP/trunk/Lib/Vis/OnlineCullingCHC/OGRE/src/OgreOcclusionCullingSceneManager.cpp	(revision 1221)
@@ -207,5 +207,5 @@
 }
 //-----------------------------------------------------------------------
-const Pass *OcclusionCullingSceneManager::_setPass(Pass* pass)
+const Pass *OcclusionCullingSceneManager::_setPass(Pass* pass, bool evenIfSuppressed)
 {
 	if (NORMAL_RENDER_HACK)
Index: GTP/trunk/Lib/Vis/OnlineCullingCHC/OGRE/src/OgreKdTreeSceneManager.cpp
===================================================================
--- GTP/trunk/Lib/Vis/OnlineCullingCHC/OGRE/src/OgreKdTreeSceneManager.cpp	(revision 1220)
+++ GTP/trunk/Lib/Vis/OnlineCullingCHC/OGRE/src/OgreKdTreeSceneManager.cpp	(revision 1221)
@@ -1109,5 +1109,5 @@
 }
 //-----------------------------------------------------------------------
-const Pass *KdTreeSceneManager::_setPass(Pass* pass)
+const Pass *KdTreeSceneManager::_setPass(Pass* pass, bool evenIfSuppressed)
 {
 	if (mRenderMethod == KdTree::KDRM_INTERNAL)
Index: GTP/trunk/Lib/Vis/OnlineCullingCHC/OGRE/src/OgreBoundingBoxConverter.cpp
===================================================================
--- GTP/trunk/Lib/Vis/OnlineCullingCHC/OGRE/src/OgreBoundingBoxConverter.cpp	(revision 944)
+++ GTP/trunk/Lib/Vis/OnlineCullingCHC/OGRE/src/OgreBoundingBoxConverter.cpp	(revision 1221)
@@ -19,5 +19,4 @@
 	GtpVisibilityPreprocessor::IndexedBoundingBoxContainer::
 		const_iterator iit, iit_end = iboxes.end();
-
   
 	for (iit = iboxes.begin(); iit != iit_end; ++ iit)
@@ -25,5 +24,4 @@
 		const GtpVisibilityPreprocessor::AxisAlignedBox3 box = (*iit).second;
 		const AxisAlignedBox currentBox = OgreTypeConverter::ConvertToOgre(box);
-
    
 		Entity *ent = FindCorrespondingObject(currentBox);
@@ -42,4 +40,5 @@
 	const float eps = 1e-3f;
 	const Vector3 veps(eps, eps, eps);
+
 	Vector3 max = box.getMaximum();
 	Vector3 min = box.getMinimum();
@@ -54,5 +53,5 @@
 	//AxisAlignedBox dummy(Vector3(-50000, -50000, -50000), Vector3(50000, 50000, 50000));
 	
-	//-- get intersecting scene nodes
+	// get intersecting scene nodes
 	mSceneMgr->findNodesIn(mybox, sceneNodeList, NULL);
 	
@@ -99,5 +98,5 @@
 				 bestFittingObj = static_cast<Entity *>(mo);
 
-				 // perfect fit => object found, eraly exit
+				 // perfect fit => object found, early exit
 				 if (overlap >= thresh)
 					 return bestFittingObj;				