Index: GTP/trunk/Lib/Vis/OnlineCullingCHC/src/GtpVisibility.pro
===================================================================
--- GTP/trunk/Lib/Vis/OnlineCullingCHC/src/GtpVisibility.pro	(revision 1226)
+++ GTP/trunk/Lib/Vis/OnlineCullingCHC/src/GtpVisibility.pro	(revision 1226)
@@ -0,0 +1,31 @@
+
+TEMPLATE = app
+
+TARGET = visibility
+
+INCLUDEPATH += ../include \
+c:/stlport-4.6.2/stlport \
+D:\gametools\ogrenew\PlugIns\OctreeSceneManager\include \
+d:/gametools/ogrenew/OgreMain/include
+
+# debuc config
+CONFIG		+= console warn_on debug thread
+
+#DEFINES 	+=EXT_HASH
+# RELEASE CONFIG
+#CONFIG		+= windows warn_on thread
+
+# DEPENDPATH	= ../../include
+
+# Input
+HEADERS += 
+
+	
+SOURCES += \
+CoherentHierarchicalCullingManager.cpp  PreprocessingManager.cpp \
+CullingManager.cpp                      QueryManager.cpp \
+DummyPreprocessingManager.cpp           StopAndWaitCullingManager.cpp \
+DummyQueryManager.cpp                   VisibilityEnvironment.cpp \
+FrustumCullingManager.cpp               VisibilityManager.cpp \
+HierarchyInterface.cpp
+
Index: GTP/trunk/Lib/Vis/OnlineCullingCHC/src/GtpVisibility.vcproj
===================================================================
--- GTP/trunk/Lib/Vis/OnlineCullingCHC/src/GtpVisibility.vcproj	(revision 1226)
+++ GTP/trunk/Lib/Vis/OnlineCullingCHC/src/GtpVisibility.vcproj	(revision 1226)
@@ -0,0 +1,198 @@
+<?xml version="1.0" encoding="Windows-1252"?>
+<VisualStudioProject
+	ProjectType="Visual C++"
+	Version="7.10"
+	Name="GtpVisibility"
+	ProjectGUID="{101A7691-74F3-48B4-96A3-CF35578F5900}"
+	Keyword="Win32Proj">
+	<Platforms>
+		<Platform
+			Name="Win32"/>
+	</Platforms>
+	<Configurations>
+		<Configuration
+			Name="Debug|Win32"
+			OutputDirectory="..\lib\$(ConfigurationName)"
+			IntermediateDirectory="..\obj\$(ConfigurationName)"
+			ConfigurationType="4"
+			CharacterSet="2">
+			<Tool
+				Name="VCCLCompilerTool"
+				Optimization="0"
+				AdditionalIncludeDirectories="&quot;$(OGRE_PATH)\OgreMain\include&quot;;..\include;..\..\Preprocessing\src"
+				PreprocessorDefinitions="WIN32;_DEBUG;_LIB;GTP_VISIBILITY_MODIFIED_OGRE"
+				MinimalRebuild="TRUE"
+				BasicRuntimeChecks="3"
+				RuntimeLibrary="3"
+				RuntimeTypeInfo="TRUE"
+				UsePrecompiledHeader="0"
+				WarningLevel="3"
+				Detect64BitPortabilityProblems="TRUE"
+				DebugInformationFormat="3"/>
+			<Tool
+				Name="VCCustomBuildTool"/>
+			<Tool
+				Name="VCLibrarianTool"
+				OutputFile="$(OutDir)/GtpVisibility.lib"/>
+			<Tool
+				Name="VCMIDLTool"/>
+			<Tool
+				Name="VCPostBuildEventTool"/>
+			<Tool
+				Name="VCPreBuildEventTool"/>
+			<Tool
+				Name="VCPreLinkEventTool"/>
+			<Tool
+				Name="VCResourceCompilerTool"/>
+			<Tool
+				Name="VCWebServiceProxyGeneratorTool"/>
+			<Tool
+				Name="VCXMLDataGeneratorTool"/>
+			<Tool
+				Name="VCManagedWrapperGeneratorTool"/>
+			<Tool
+				Name="VCAuxiliaryManagedWrapperGeneratorTool"/>
+		</Configuration>
+		<Configuration
+			Name="Release|Win32"
+			OutputDirectory="..\lib\$(ConfigurationName)"
+			IntermediateDirectory="..\obj\$(ConfigurationName)"
+			ConfigurationType="4"
+			CharacterSet="2">
+			<Tool
+				Name="VCCLCompilerTool"
+				OptimizeForWindowsApplication="TRUE"
+				AdditionalIncludeDirectories="..\include;&quot;$(OGRE_PATH)\OgreMain\include&quot;;..\..\Preprocessing\src"
+				PreprocessorDefinitions="WIN32;NDEBUG;_LIB"
+				RuntimeLibrary="2"
+				RuntimeTypeInfo="TRUE"
+				UsePrecompiledHeader="0"
+				WarningLevel="3"
+				Detect64BitPortabilityProblems="TRUE"
+				DebugInformationFormat="3"/>
+			<Tool
+				Name="VCCustomBuildTool"/>
+			<Tool
+				Name="VCLibrarianTool"
+				OutputFile="$(OutDir)/GtpVisibility.lib"/>
+			<Tool
+				Name="VCMIDLTool"/>
+			<Tool
+				Name="VCPostBuildEventTool"/>
+			<Tool
+				Name="VCPreBuildEventTool"/>
+			<Tool
+				Name="VCPreLinkEventTool"/>
+			<Tool
+				Name="VCResourceCompilerTool"/>
+			<Tool
+				Name="VCWebServiceProxyGeneratorTool"/>
+			<Tool
+				Name="VCXMLDataGeneratorTool"/>
+			<Tool
+				Name="VCManagedWrapperGeneratorTool"/>
+			<Tool
+				Name="VCAuxiliaryManagedWrapperGeneratorTool"/>
+		</Configuration>
+	</Configurations>
+	<References>
+	</References>
+	<Files>
+		<Filter
+			Name="Source Files"
+			Filter="cpp;c;cxx;def;odl;idl;hpj;bat;asm;asmx"
+			UniqueIdentifier="{4FC737F1-C7A5-4376-A066-2A32D752A2FF}">
+			<File
+				RelativePath="..\src\BatchedQueriesCullingManager.cpp">
+			</File>
+			<File
+				RelativePath="..\src\CoherentHierarchicalCullingManager.cpp">
+			</File>
+			<File
+				RelativePath="..\src\CullingManager.cpp">
+			</File>
+			<File
+				RelativePath="..\src\DummyPreprocessingManager.cpp">
+			</File>
+			<File
+				RelativePath="..\src\FrustumCullingManager.cpp">
+			</File>
+			<File
+				RelativePath="..\src\HierarchyInterface.cpp">
+			</File>
+			<File
+				RelativePath="..\src\PreprocessingManager.cpp">
+			</File>
+			<File
+				RelativePath="..\src\QueryManager.cpp">
+			</File>
+			<File
+				RelativePath="..\include\QueryManager.h">
+			</File>
+			<File
+				RelativePath="..\src\StopAndWaitCullingManager.cpp">
+			</File>
+			<File
+				RelativePath="..\src\VisibilityEnvironment.cpp">
+			</File>
+			<File
+				RelativePath="..\src\VisibilityManager.cpp">
+			</File>
+		</Filter>
+		<Filter
+			Name="Header Files"
+			Filter="h;hpp;hxx;hm;inl;inc;xsd"
+			UniqueIdentifier="{93995380-89BD-4b04-88EB-625FBE52EBFB}">
+			<File
+				RelativePath="..\include\BatchedQueriesCullingManager.h">
+			</File>
+			<File
+				RelativePath="..\include\CoherentHierarchicalCullingManager.h">
+			</File>
+			<File
+				RelativePath="..\include\CullingManager.h">
+			</File>
+			<File
+				RelativePath="..\include\DistanceQueue.h">
+			</File>
+			<File
+				RelativePath="..\include\DummyPreprocessingManager.h">
+			</File>
+			<File
+				RelativePath="..\include\DummyQueryManager.h">
+			</File>
+			<File
+				RelativePath="..\include\FrustumCullingManager.h">
+			</File>
+			<File
+				RelativePath="..\include\HierarchyInterface.h">
+			</File>
+			<File
+				RelativePath="..\include\OcclusionQuery.h">
+			</File>
+			<File
+				RelativePath="..\include\PreprocessingManager.h">
+			</File>
+			<File
+				RelativePath="..\include\StopAndWaitCullingManager.h">
+			</File>
+			<File
+				RelativePath="..\include\VisibilityEnvironment.h">
+			</File>
+			<File
+				RelativePath="..\include\VisibilityInfo.h">
+			</File>
+			<File
+				RelativePath="..\include\VisibilityManager.h">
+			</File>
+			<File
+				RelativePath="..\include\VisibilityMesh.h">
+			</File>
+		</Filter>
+		<File
+			RelativePath=".\VTune\GtpVisibility.vpj">
+		</File>
+	</Files>
+	<Globals>
+	</Globals>
+</VisualStudioProject>